=== modified file 'dev.cfg'
--- dev.cfg	2006-12-14 05:25:41 +0000
+++ dev.cfg	2006-12-15 09:20:04 +0000
@@ -45,16 +45,6 @@
 # turn on timer scheduling
 tg.scheduler = True
 
-#loggerhead.folder='/Users/robey/code/paramiko/paramiko'
-#loggerhead.branch_name='paramiko-dev'
-loggerhead.folder='/Users/robey/code/bzr/bzr.dev'
-loggerhead.branch_name='bzr.dev'
-loggerhead.cachepath='/Users/robey/code/bzr/bzr.dev/.bzr/loggerhead-cache'
-loggerhead.external_url="http://localhost:8080"
-loggerhead.bzrpath='/Users/robey/code/bzr/bzr'
-
-
-
 # LOGGING
 # Logging configuration generally follows the style of the standard
 # Python logging module configuration. Note that when specifying

=== added file 'loggerhead.conf'
--- loggerhead.conf	1970-01-01 00:00:00 +0000
+++ loggerhead.conf	2006-12-15 09:20:04 +0000
@@ -0,0 +1,16 @@
+
+# where is the bazaar branch located, and what should we call it?
+folder='/Users/robey/code/bzr/bzr.dev'
+branch_name='bzr.dev'
+
+# should we cache revisions?  (HIGHLY recommended)  where?
+# this will be a folder containing a couple of files.  if the folder
+# doesn't already exist, we'll create it.
+cachepath='/Users/robey/code/bzr/bzr.dev/.bzr/loggerhead-cache'
+
+# what url should i use in the atom feed, for external sites?
+external_url="http://localhost:8080"
+
+# where's bzrlib?
+bzrpath='/Users/robey/code/bzr/bzr'
+

=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2006-12-15 08:42:22 +0000
+++ loggerhead/TODO	2006-12-15 09:20:04 +0000
@@ -1,4 +1,6 @@
 
+* config file
+
 * maybe put this at the footer of each page:
     paramiko-dev, 419 revisions, 1133 days old
     first revision: Tue 2003-11-04 08:34:24 +0000

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2006-12-15 08:42:22 +0000
+++ loggerhead/controllers/__init__.py	2006-12-15 09:20:04 +0000
@@ -20,18 +20,23 @@
 import logging
 import time
 
+from configobj import ConfigObj
+
 import turbogears
 from turbogears import controllers
 from cherrypy import HTTPRedirect, NotFound
 
+from loggerhead import util
+
+my_config = ConfigObj('loggerhead.conf', encoding='utf-8')
+util.set_config(my_config)
+
 from loggerhead.controllers.changelog_ui import ChangeLogUI
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.annotate_ui import AnnotateUI
 from loggerhead.history import History
-from loggerhead import util
-
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -50,6 +55,8 @@
 # force history to be read:
 util.get_history()
 
+
+
 def rebuild_cache():
     log.info('Rebuilding revision cache...')
     last_update = time.time()

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2006-12-15 08:42:22 +0000
+++ loggerhead/controllers/annotate_ui.py	2006-12-15 09:20:04 +0000
@@ -66,7 +66,7 @@
         navigation = util.Container()
 
         vals = {
-            'branch_name': turbogears.config.get('loggerhead.branch_name'),
+            'branch_name': util.get_config().get('branch_name'),
             'util': util,
             'revid': revid,
             'path': path,

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2006-12-15 08:42:22 +0000
+++ loggerhead/controllers/atom_ui.py	2006-12-15 09:20:04 +0000
@@ -37,8 +37,8 @@
         entries = list(h.get_changelist(list(revlist)[:20]))
 
         vals = {
-            'external_url': turbogears.config.get('loggerhead.external_url'),
-            'branch_name': turboears.config.get('loggerhead.branch_name'),
+            'external_url': util.get_config().get('external_url'),
+            'branch_name': util.get_config().get('branch_name'),
             'changes': entries,
             'util': util,
             'history': h,

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-15 08:42:22 +0000
+++ loggerhead/controllers/changelog_ui.py	2006-12-15 09:20:04 +0000
@@ -61,7 +61,7 @@
 
         path = kw.get('path', None)
         start_revid = h.fix_revid(kw.get('start_revid', None))
-        pagesize = int(turbogears.config.get('loggerhead.pagesize', '20'))
+        pagesize = int(util.get_config().get('pagesize', '20'))
         
         try:
             revlist, start_revid = h.get_navigation(start_revid, path)
@@ -90,7 +90,7 @@
                 p.branch_nick = h.get_change(p.revid).branch_nick
 
         vals = {
-            'branch_name': turbogears.config.get('loggerhead.branch_name'),
+            'branch_name': util.get_config().get('branch_name'),
             'changes': list(entries),
             'util': util,
             'history': h,

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2006-12-15 08:42:22 +0000
+++ loggerhead/controllers/inventory_ui.py	2006-12-15 09:20:04 +0000
@@ -80,7 +80,7 @@
             p.branch_nick = h.get_change(p.revid).branch_nick
 
         vals = {
-            'branch_name': turbogears.config.get('loggerhead.branch_name'),
+            'branch_name': util.get_config().get('branch_name'),
             'util': util,
             'revid': revid,
             'change': change,

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-15 08:42:22 +0000
+++ loggerhead/controllers/revision_ui.py	2006-12-15 09:20:04 +0000
@@ -67,7 +67,7 @@
             p.branch_nick = h.get_change(p.revid).branch_nick
         
         vals = {
-            'branch_name': turbogears.config.get('loggerhead.branch_name'),
+            'branch_name': util.get_config().get('branch_name'),
             'revid': revid,
             'change': change,
             'start_revid': start_revid,

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-15 08:42:22 +0000
+++ loggerhead/history.py	2006-12-15 09:20:04 +0000
@@ -30,8 +30,10 @@
 import time
 from StringIO import StringIO
 
-import turbogears
-sys.path.insert(0, turbogears.config.get('loggerhead.bzrpath', ''))
+from loggerhead import util
+extra_path = util.get_config().get('bzrpath', None)
+if extra_path:
+    sys.path.insert(0, extra_path)
 
 import bzrlib
 import bzrlib.annotate
@@ -43,7 +45,6 @@
 import bzrlib.tsort
 import bzrlib.ui
 
-from loggerhead import util
 
 log = logging.getLogger("loggerhead.controllers")
 

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2006-12-15 08:42:22 +0000
+++ loggerhead/util.py	2006-12-15 09:20:04 +0000
@@ -219,15 +219,27 @@
     global _history
     from loggerhead.history import History
     
+    config = get_config()
+    
     _history_lock.acquire()
     try:
         if (_history is None) or _history.out_of_date():
             log.debug('Reload branch history...')
             if _history is not None:
                 _history.dont_use_cache()
-            _history = History.from_folder(turbogears.config.get('loggerhead.folder'))
-            _history.use_cache(turbogears.config.get('loggerhead.cachepath'))
+            _history = History.from_folder(config.get('folder'))
+            _history.use_cache(config.get('cachepath'))
         return _history
     finally:
         _history_lock.release()
 
+
+_config = None
+
+def set_config(config):
+    global _config
+    _config = config
+
+def get_config():
+    return _config
+

